

$regfile = "m8def.dat"
$crystal = 1000000
'------------------------  lcd -----------------------------------------------
Config Lcd = 16 * 2
Config Lcdpin = Pin , Rs = Pind.0 , E = Pind.1 , Db4 = Pind.2 , Db5 = Pind.3 , Db6 = Pind.4 , Db7 = Pind.5
Cls

'---------------------------  ds 1307 -----------------------------------------
$lib "ds1307clock.lib"
'configure the scl and sda pins
Config Sda = Portd.7
Config Scl = Portd.6
'address of ds1307
Const Ds1307w = &HD0
Const Ds1307r = &HD1
'------------------------------ key --------------------------------------------

Config Pinc.2 = Input
Config Pinc.3 = Input

'------------------------------------------------------------------------------
Config Debounce = 30

Dim A As Byte , B As Byte , Data1 As Byte , C As Byte

Dim Seco As Byte , Mine As Byte , Hour As Byte
Dim K As String * 15
Dim W As Byte

'----------------------------------------------------------------------------
Cursor Off

I2cstart
        I2cwbyte Ds1307w
        I2cwbyte 0
        I2cstart
        I2cwbyte Ds1307r
        I2crbyte Seco , Ack
        I2crbyte Mine , Ack
        I2crbyte Hour , Nack
        I2cstop
        Gosub Seco
'-----------------------------
Cls

K = "MAMALI"

Locate 2 , 1

Lcd "Dash ALI"

For W = 1 To 16

Locate 1 , W

Lcd " " ; K

 Waitms 300


Next

Cls
'-------------------------------------------------------------------------------
Main:
Do
         Gosub Ds1307
         Gosub Disply_24
         Gosub Chekkey

Loop
'-------------------------------------------------------------------------------
Ds1307:
        I2cstart
        I2cwbyte Ds1307w
        I2cwbyte 0
        I2cstart
        I2cwbyte Ds1307r
        I2crbyte Seco , Ack
        I2crbyte Mine , Ack
        I2crbyte Hour , Nack
        I2cstop

        Seco = Makedec(seco) : Mine = Makedec(mine) : Hour = Makedec(hour)

        If Seco > 59 Then Seco = 0
        If Mine > 59 Then Mine = 0
        If Hour > 23 Then
        Hour = 0
        Gosub Seco
        End If

Return
'-------------------------------------------------------------------------------


Disply_24:

         Locate 1 , 1
         Lcd "Time = " ; Hour ; ":" ; Mine ; ":" ; Seco ; "      "


Return

'-------------------------------------------------------------------------------


Chekkey:


         Debounce Pinc.2 , 0 , Mine , Sub
         Debounce Pinc.3 , 0 , Hour , Sub


Return
'---------------------------------------------
Seco:
         Incr Seco
         If Seco > 59 Then Seco = 0
         Seco = Makebcd(seco)
         I2cstart
         I2cwbyte Ds1307w
         I2cwbyte 0
         I2cwbyte Seco
         I2cstop
Return

'-------------------------------------
Mine:
         Incr Mine
         If Mine > 59 Then Mine = 0
         Mine = Makebcd(mine)
         I2cstart
         I2cwbyte Ds1307w
         I2cwbyte 1
         I2cwbyte Mine
         I2cstop
Return
'-------------------------------------

Hour:
         Incr Hour
         If Hour > 23 Then Hour = 0
         Hour = Makebcd(hour)
         I2cstart
         I2cwbyte Ds1307w
         I2cwbyte 2
         I2cwbyte Hour
         I2cstop

Return
'-------------------------------------

End